#pragma once

#ifdef COM_EXPORTS
#define COM_API __declspec(dllexport)
#else
#define COM_API __declspec(dllimport)
#endif

#include "com.h"

#include <string>
#include <vector>
using std::string;
using std::vector;

class CCommPort;

#define SN_LEN 19
#define SetGet8(func)  bool Set##func(u8 u); bool Get##func(u8& u);
#define SetGet16(func) bool Set##func(u16 u); bool Get##func(u16& u);
#define SetGet32(func) bool Set##func(u32 u); bool Get##func(u32& u);

class COM_API PVCom
{
public:
    PVCom();
    ~PVCom();

    void SetInitOK(bool ok) { m_init = ok; }
    bool InitOK() const { return m_init; }
    
    void SetLogDetail(bool detail) { m_logDetail = detail; }
    bool IsLogDetail() const { return m_logDetail; }
       
    static void GetAllComms(vector<string>& v);
    bool Init(const char* port, int baud=9600, u8 addr=0, u8 head=0xAA);
    bool FInit();

    string GetLasterr() const { return m_lasterr; }

    void SetDefaultTimeout(DWORD timeout);

    bool GetCVPR(                       // 0x01 ȡѶϢ
        u32& maxCurrent,    // 
        u32& maxVoltage,    // ѹ
        u32& minVoltage,    // Сѹ
        u32& maxPower,      // 
        u32& maxR,          // 
        u16& minR);         // С
    SetGet32(OPP);                      // 0x02 0x03 ûȡӲʱֵ
	bool ReadSerialNum(u8 *pSN,u8 len);	// 0x04 0x2d ȡк,pSNַlenʾ(>=SN_LEN)        
    SetGet8 (VONMode);                  // 0x0E 0x0F ûȡVONģʽ PV_LIVING PV_LATCH
    SetGet32(VONVoltage);               // 0x10 0x11 öȡVONѹֵ

    bool SetPCControl(u8 u);            // 0x20  ģʽ PV_Device 豸  PV_PC ܿ
    bool SetInputState(u8 state);       // 0x21  ״̬ (PV_ON / PV_OFF)
    SetGet32(MaxV);                     // 0x22 0x23 ûȡ ѹֵ λΪ mV
    SetGet32(MaxC);                     // 0x24 0x25 ûȡֵ !!! λ 0.1 mA
    SetGet32(MaxW);                     // 0x26 0x27 ûȡֵ λ mw
    SetGet8(CVWRMode);                  // 0x28 0x29 ûȡģʽ PV_CC PV_CV PV_CW PV_CR 
    SetGet32(C);                        // 0x2A 0x2B ûȡ
    SetGet32(V);                        // 0x2C 0x2D ûȡѹ
    SetGet32(W);                        // 0x2E 0x2F ûȡ

    SetGet32(R);                        // 0x30 0x31 ûȡ  λ mR  R/1000
    bool SetDynamicCArgs(               // 0x32  øصĶֵ̬
        u32 currentA,       // A 趨ֵ
        u16 currentATime,   // A ʱֵ λ 0.1ms
        u32 currentB,       // B 趨ֵ
        u16 currentBTime,   // B ʱֵ λ 0.1ms
        u8  dynamicMode);   // ̬ģʽ PV_CONTINUE PV_PULSE PV_TOGGLED
    bool GetDynamicCArgs(               // 0x33  ȡصĶֵ̬
        u32& currentA,      // A 趨ֵ
        u16& currentATime,  // A ʱֵ λ 0.1ms
        u32& currentB,      // B 趨ֵ
        u16& currentBTime,  // B ʱֵ λ 0.1ms
        u8&  dynamicMode);  // ̬ģʽ PV_CONTINUE PV_PULSE PV_TOGGLED
    bool SetDynamicVArgs(               // 0x34  øصĶ̬ѹֵ
        u32 VoltageA,       // ѹA 趨ֵ
        u16 VoltageATime,   // ѹA ʱֵ λ 0.1ms
        u32 VoltageB,       // ѹB 趨ֵ
        u16 VoltageBTime,   // ѹB ʱֵ λ 0.1ms
        u8  dynamicMode);   // ̬ģʽ PV_CONTINUE PV_PULSE PV_TOGGLED
    bool GetDynamicVArgs(               // 0x35  ȡصĶ̬ѹֵ
        u32& VoltageA,      // ѹA 趨ֵ
        u16& VoltageATime,  // ѹA ʱֵ λ 0.1ms
        u32& VoltageB,      // ѹB 趨ֵ
        u16& VoltageBTime,  // ѹB ʱֵ λ 0.1ms
        u8&  dynamicMode);  // ̬ģʽ PV_CONTINUE PV_PULSE PV_TOGGLED
    bool SetDynamicPArgs(               // 0x36  øصĶ̬ʲֵ
        u32 powerA,       // A 趨ֵ
        u16 powerATime,   // A ʱֵ λ 0.1ms
        u32 powerB,       // B 趨ֵ
        u16 powerBTime,   // B ʱֵ λ 0.1ms
        u8  dynamicMode); // ̬ģʽ PV_CONTINUE PV_PULSE PV_TOGGLED
    bool GetDynamicPArgs(               // 0x37  ȡصĶ̬ʲֵ
        u32& powerA,      // A 趨ֵ
        u16& powerATime,  // A ʱֵ λ 0.1ms
        u32& powerB,      // B 趨ֵ
        u16& powerBTime,  // B ʱֵ λ 0.1ms
        u8&  dynamicMode);// ̬ģʽ PV_CONTINUE PV_PULSE PV_TOGGLED
    bool SetDynamicRArgs(               // 0x38  øصĶֵ̬
        u32 resistanceA,     // A 趨ֵ
        u16 resistanceATime, // A ʱֵ λ 0.1ms
        u32 resistanceB,     // B 趨ֵ
        u16 resistanceBTime, // B ʱֵ λ 0.1ms
        u8  dynamicMode);    // ̬ģʽ PV_CONTINUE PV_PULSE PV_TOGGLED
    bool GetDynamicRArgs(               // 0x39  ȡصĶֵ̬
        u32& resistanceA,    // A 趨ֵ
        u16& resistanceATime,// A ʱֵ λ 0.1ms
        u32& resistanceB,    // B 趨ֵ
        u16& resistanceBTime,// B ʱֵ λ 0.1ms
        u8&  dynamicMode);   // ̬ģʽ PV_CONTINUE PV_PULSE PV_TOGGLED
    SetGet8 (ListCVWR);                 // 0x3A 0x3B PV_CC ֻ
    SetGet8 (ListMode);                 // 0x3C 0x3D 1 1  2 2 255 ѭ
    SetGet8 (ListStep);                 // 0x3E 0x3F ûȡList

    bool SetListStepCTime(              // 0x40 ûȡصӦĵֵʱֵб(40H/41H) 
        u16 step, u32 c, 
        u32 time, u16 rate);     // time 1 ʾ 0.1ms
    bool GetListStepCTime(              // 0x41
        u16 step, u32& c, 
        u32& time, u16& rate);  
    // 6 ָ ն δʵ
    bool SetListStepVTime(              // 0x42 ûȡصӦĵѹֵʱֵ(42H/43H)
        u16 step, u32 v, 
        u32 time, u16 rate);     // time 1 ʾ 0.1ms
    bool GetListStepVTime(              // 0x43
        u16 step, u32& v, 
        u32& time, u16& rate);  
    bool SetListStepWTime(              // 0x44 ûȡصӦĹֵʱֵ(44H/45H)
        u16 step, u32 w, 
        u32 time, u16 rate);     // time 1 ʾ 0.1ms
    bool GetListStepWTime(              // 0x45
        u16 step, u32& w, 
        u32& time, u16& rate); 
    bool SetListStepRTime(              // 0x46 ûȡصӦĵֵʱֵ(46H/47H) 
        u16 step, u32 r, u32 
        time, u16 rate);     // time 1 ʾ 0.1ms
    bool GetListStepRTime(              // 0x47
        u16 step, u32& r, 
        u32& time, u16& rate); 
    // 0x48 λûʵ
    // 0x49 λûʵ
    SetGet8 (ListPartition);            // 0x4A 0xAB ûȡصListģʽ (1|2|4|8)
    bool SaveListFile(u8 u);            // 0x4C Listļ(1~8) ram --> rom
    bool LoadListFile(u8 u);            // 0x4D Listļ(1~8) rom --> ram
    SetGet32(MinV);                     // 0x4E 0x4F ûȡڶѹģʽµСѹֵ
    
    SetGet16(ForloadTime);              // 0x50	0x51 øصFOR LOAD ON ʱʱֵ λ s
    SetGet8 (ForloadState);             // 0x52 0x53 (PV_OFF / PV_ON) ûȡFOR LOAD ON ʱ״̬
    bool SetNewAddr(u8 addr);           // 0x54 øصͨѶַ
    bool SetEnableLocal(u8 forbid);     // 0x55 ǷLOCAL ʹ PV_OFF / PV_ON 
    SetGet8 (RemoteMesure);             // 0x56 0x57 ûȡԶ̲ PV_Remote PV_Local
    SetGet8 (TrigMode);                 // 0x58 0x59 ûȡģʽ PV_TrigMAUNal PV_TrigEXTernal PV_TrigBUS PV_TrigHOLD
    bool SendBusSignal();               // 0x5A ͸һBUS ʹź
    bool SetArgument(u8 arg);           // 0x5B øز arg ָ λsaveֵ
    bool LoadArgument(u8 arg);          // 0x5C ȡز
    SetGet8 (WorkMode);                 // 0x5D 0x5E ûȡģʽ (PV_WorkFIXED PV_WorkSHORT PV_WorkTRANSITION PV_WorkLIST PV_BATTERY)
    /*                                  // 0x5F ȡ״̬

    ״̬Ĵ
    7	6	5	4	3	2	1	0
    7 NO USE	
    6 LOT	FOR LOAD ON ʱ״̬
    5 SENSE	Զ˲ģʽ״̬
    4 LOCAL	LOCAL״̬(0 Ϊֹ,1 Ϊ)
    3 OUT	״̬
    2 REM	ΪԶ˿ģʽ
    1 WTG	ڵȴź
    0 CAL   У׼ģʽ
    						
    ѯ״̬Ĵ
    0	RV	뼫Է
    1	OV	ѹ
    2	OC	
    3	OP	
    4	OT	¶
    5	SV	Զû
    6	CC	
    7	CV	ѹ
    8	CW	
    9	CR	
    10	PASS	ԶԳɹ
    11	FAULT	Զʧ
    12	COMPLET	Զ
    */
    bool GetStates(                     
        u32& actualInputV,  // ʵѹ
        u32& actualInputC,  // ʵ
        u32& actualInputW,  // ʵ빦
        u8&  operateState,  // ״̬Ĵ
        u16& queryState,    // ѯ״̬Ĵ
        u8&  fanTemperature,// ɢ¶
        u8&  workMode,      // ģʽ (0ΪPV_WorkFIXED1ΪPV_WorkSHORT
                            //           2ΪPV_WorkTRANSITION3ΪPV_WorkLIST)
        u8&  curlistStep,   // ǰLISTĲ
        u8&  curlistCirCnt  // ǰLISTѭ
        );

    // У׼
//    SetGet8(AdjustProtect);             // 0x60 0x61 ûȡУ׼״̬  
	bool SetAdjustProtect(u8 state);//0x60stateֵΪ0ʾʧܣ0ʾʹ
	bool GetAdjustProtect(u8 &v);//0x61
                                        //      PV_AdjustProtectEnable PV_AdjustProtectDisable
    bool SetAdjustVPoint(u8 u);         // 0x62 У׼صѹ  u ѹУ׼(1 ~ 4)
    bool SetAdjustActualV(u32 v);      // 0x63 ȡǰʵѹ
    bool SetAdjustCPoint(u8 u);         // 0x64 У׼ص  u У׼(1 ~ 4)
    bool SetAdjustActualC(u32 c);       // 0x65 ȡǰʵ
    bool SaveAdjust();                  // 0x66 渺صûУ׼ݵEEPROM
    bool SaveAdjustInfo(                // 0x67 У׼Ϣ Ҫ20ֽ(ַĩβ\0)
        const string& info); 
    bool GetAdjustInfo(string& info);   // 0x68 ȡУ׼Ϣ,ȡУ׼Ϣ
    bool SetAdjustInit();               // 0x69 ָصУ׼Ϊʼֵ
    bool GetDevInfo(                    // 0x6A ȡƷϢ
        string& product,    // Ʒͺ 8511?   6011? ϢΪ 0x60У׼
        string& softVersion,// 汾ͺ
        string& sequence    // Ϊݶڣʵֵһֱǿַ
        );      
    bool GetDevInfo(); 
    // TODO: ע
    bool GetPowerInfo(string& power);   // 0x6B ȡԴϢ
    
    SetGet32(OCPValue);                 // 0x80 0x81 ûȡֵ
    SetGet8 (OCPTime);                  // 0x82 0x83 ûȡʱʱ
    SetGet8 (OCPState);                 // 0x84 0x85 ûȡʹ/ʧ״̬
    SetGet32(OPPValue);                 // 0x86 0x87 ûȡʱֵ
    SetGet8 (OPPTime);                  // 0x88 0x89 ûȡʱʱʱ
    SetGet32(TimeV1);                   // 0x8A 0x8B ûȡʱĵ1Ƚϵѹ
    SetGet32(TimeV2);                   // 0x8C 0x8D ûȡʱĵ2Ƚϵѹ
    SetGet32(LEDV);                     // 0x8E 0x8F ûȡCR_LEDģʽĽֹѹֵ

    bool ClearProtect();                // 0x90 ״̬
    SetGet8 (VAutoState);               // 0x91 0x92 ûȡѹԶ״̬PV_OFF PV_ON
    SetGet8 (CRLED);                    // 0x93 0x94 ûȡCRģʽʱCR_LEDPV_OFF PV_ON
    SetGet8 (Keydown);                  // 0x98 ģ̰ keyCodeģֵ̱
                                        // 0x99 ȡһμֵ keyCode һμֵ,0 
    SetGet8 (VFDMode);                  // 0x9A 0x9B ûȡVFDʾģʽ PV_VFDNormal PV_VFDText
    bool SetVFDText(u8 startPos,        // 0x9C VFDʾ
        const string& text);
    bool SendTrig();                    // 0x9D ܴԴʲôź

    bool GetStates2(                    // 0xA0 ȡ2
        u32& capacity,  // 
        u32& time,      // ʱ/½ʱ(ֽǰ,ֽں) 
        u32& restTimer);// ʱʣʱ        
    bool GetStates3(                    // 0xA1 ȡ3
        u32& maxInputV,  // ѹֵ
        u32& minInputV,  // Сѹֵ
        u32& maxInputC,  // ֵ
        u32& minInputC); // Сֵ
    bool GetMaxInputV(u32& v);          // 0xA2 ȡѹֵ
    bool GetMinInputV(u32& v);          // 0xA3 ȡСѹֵ
    bool GetMaxInputC(u32& c);          // 0xA4 ȡֵ
    bool GetMinInputC(u32& c);          // 0xA5 ȡСֵ
    bool GetCapacity(u32& capacity);    // 0xA6 ȡصĴֵ

    SetGet32(CUpRate);                  // 0xB0 0xB1 õб 10000 
    SetGet32(CDownRate);                // 0xB2 0xB3 õб
    SetGet32(CCMaxVoltage);             // 0xB4 0xB5 öʱѹ
    SetGet32(CCMinVoltage);             // 0xB6 0xB7 öʱѹ
    SetGet32(CVMaxCurrent);             // 0xB8 0xB9 öѹʱ
    SetGet32(CVMinCurrent);             // 0xBA 0xBB öѹʱ
    SetGet32(CPMaxVoltage);             // 0xBC 0xBD öʱѹ
    SetGet32(CPMinVoltage);             // 0xBE 0xBF öʱѹ

    SetGet32(MaxInputR);                // 0xC0	0xC1 ûȡֵ
    SetGet32(CRMaxVoltage);             // 0xC2 0xC3 ûȡʱѹ
    SetGet32(CRMinVoltage);             // 0xC4 0xC5 ûȡʱѹ
    SetGet32(ListC);                    // 0xC6 0xC7 ûȡLISTģʽʱ

    SetGet16(StepNumber);               // 0xD0 0xD1 ûȡԶʹõĵ
    SetGet16(ShortStep);                // 0xD2 0xD3 ûȡԶԶ·ĵ
    SetGet16(PauseStep);                // 0xD4 0xD5 ûȡԶͣĵ
    
    bool SetStepOnTime(u8 step, u32 time);// 0xD6 ԶԵĴʱ
    bool GetStepOnTime(u8 step, u32& time);// 0xD7
    bool SetStepOffTime(u8 step, u32 time);// 0xDA ԶԵжʱ
    bool GetStepOffTime(u8 step, u32& time);// 0xDB
    SetGet8(StepStop);                  /* 0xDC 0xDD ûȡԶֹͣ
                                          (0Ϊֹͣ,1Ϊʧֹͣ) */
    SetGet8(LinkFile);                  // 0xDE 0xDF ûȡԶļ

    virtual bool AutoTest();

    void Flush();

#undef SetGet8
#undef SetGet16
#undef SetGet32

    string AckToString() { return ToString(ack, Length()); }
    string SendToString() { return ToString(send, Length()); }
protected:
    CCommPort* Comm() { return m_com; }

    bool Setu0(u8 cmdByte);
    bool Setu8(u8 u, u8 cmdByte);
    bool Setu8(u8 u, u8 cmdByte,DWORD sendTimeout,DWORD recvTimeout);
    bool Getu8(u8& u, u8 cmdByte);
    bool Setu16(u16 u, u8 cmdByte,DWORD sendTimeout,DWORD recvTimeout);
    bool Setu16(u16 u, u8 cmdByte);
    bool Getu16(u16& u, u8 cmdByte);
    bool Setu32(u32 u, u8 cmdByte,DWORD sendTimeout,DWORD recvTimeout);
    bool Setu32(u32 u, u8 cmdByte);
    bool Getu32(u32& u, u8 cmdByte);
    bool Setu16u32u32u16(u16 step, u32 u32val, u32 time, u16 rate, u8 cmdByte);
    bool Getu16u32u32u16(u16 step, u32& u32val, u32& time, u16& rate, u8 cmdByte);
    bool Set42421(u32 arg1, u16 arg2, u32 arg3, u16 arg4, u8 arg5, u8 cmdByte);
    bool Get42421(u32& arg1, u16& arg2, u32& arg3, u16& arg4, u8& arg5, u8 cmdByte);
    bool GetStr(string& s, int len, u8 cmdByte);
    bool SetStr(const string& s, int len, u8 cmdByte);

    enum { FRAME_LENGTH = 26 }; // ֵ Ҫı
    unsigned char send[FRAME_LENGTH+1];
    unsigned char ack[FRAME_LENGTH+1];

    int Length() const { return FRAME_LENGTH; }

    void Clear();
    void FillVerify();  // У
    bool VerifyAck();  
    bool VerifyChecksum();
    bool HandleSetCmd(DWORD sendTimeout,DWORD recvTimeout);
    bool HandleSetCmd();
    bool HandleGetCmd();
    bool HandleGetCmd(u8 cmdByte);
    bool SendCmdAndRecv(DWORD sendTimeout,DWORD recvTimeout);
    bool Recv(DWORD recvTimeout);
	bool CheckPacketHead(DWORD timeout);
    
    string ToString(unsigned char* s, int len);

    bool m_logDetail;       // ѡ Ƿ־ϸ¼ͨ

    unsigned char m_pvhead;
    unsigned char m_pvaddr;

    string m_lasterr;
    bool   m_init;

    // ƷϢ ЩϢ  init ʱԶ豸ȡ
    u8     m_productLow;
    u8     m_productHigh;
    string m_product;
    string m_softVerison;
    u8     m_softVersionLow;
    u8     m_softVersionHigh;
    string m_sequence;
    CCommPort* m_com;

    //
    DWORD m_defaultTimeout;
};
