#ifndef ZY_PVCOMC_H_20141008
#define ZY_PVCOMC_H_20141008

#ifndef COM_API
    #ifdef COM_EXPORTS
    #define COM_API __declspec(dllexport)
    #else
    #define COM_API __declspec(dllimport)
    #endif
#endif

#ifdef  __cplusplus
extern "C" {
#endif

#include "com.h"

typedef struct zelstr
{
    char s[27];
    struct zelstr* next;
}zelstr, *pzelstr;

struct ComBody;
typedef struct ComBody* PComBody;

#define SetGet8(func)  int (*Set##func)(PComBody c, u8 u); int (*Get##func)(PComBody c, u8* u)
#define SetGet16(func) int (*Set##func)(PComBody c, u16 u); int (*Get##func)(PComBody c, u16* u)
#define SetGet32(func) int (*Set##func)(PComBody c, u32 u); int (*Get##func)(PComBody c, u32* u)

typedef struct ZELComI
{
    PComBody (*Create)();
    void (*Destroy)(PComBody* c);

    int  (*Init)(PComBody c, const char* port, int baud, u8 addr);
    int  (*InitOK)(PComBody c);

    void (*SetLogDetail)(PComBody c, int logDetail);
    int  (*GetLogDetail)(PComBody c);

    /* ȡǰеĴ */
    pzelstr (*GetAllComs)();
    void (*FreeComs)(pzelstr* s);

    int (*GetCVPR)(PComBody c, /* 0x01 ȡѶϢ */
        u32* maxCurrent,    /*  */
        u32* maxVoltage,    /* ѹ */
        u32* minVoltage,    /* Сѹ */
        u32* maxPower,      /*  */
        u32* maxR,          /*  */
        u16* minR);         /* С */
    SetGet32(OPP);                      /* 0x02 0x03 ûȡӲʱֵ*/
    SetGet8 (VONMode);                  // 0x0E 0x0F ûȡVONģʽ PV_LIVING PV_LATCH
    SetGet32(VONVoltage);               // 0x10 0x11 öȡVONѹֵ

    int  (*SetPCControl)(PComBody c,u8 u);         // 0x20  ģʽ PV_Device 豸  PV_PC ܿ
    int  (*SetInputState)(PComBody c,u8 state);    // 0x21  ״̬ (PV_ON / PV_OFF)
    SetGet32(MaxV);                     // 0x22 0x23 ûȡ ѹֵ λΪ mV
    SetGet32(MaxC);                     // 0x24 0x25 ûȡֵ !!! λ 0.1 mA
    SetGet32(MaxW);                     // 0x26 0x27 ûȡֵ λ mw
    SetGet8(CVWRMode);                  // 0x28 0x29 ûȡģʽ PV_CC PV_CV PV_CW PV_CR 
    SetGet32(C);                        // 0x2A 0x2B ûȡ
    SetGet32(V);                        // 0x2C 0x2D ûȡѹ
    SetGet32(W);                        // 0x2E 0x2F ûȡ

    SetGet32(R);                        // 0x30 0x31 ûȡ  λ mR  R/1000
    int  (*SetDynamicCArgs)(PComBody c,               // 0x32  øصĶֵ̬
        u32 currentA,       // A 趨ֵ
        u16 currentATime,   // A ʱֵ λ 0.1ms
        u32 currentB,       // B 趨ֵ
        u16 currentBTime,   // B ʱֵ λ 0.1ms
        u8  dynamicMode);   // ̬ģʽ PV_CONTINUE PV_PULSE PV_TOGGLED
    int  (*GetDynamicCArgs)(PComBody c,               // 0x33  ȡصĶֵ̬
        u32* currentA,      // A 趨ֵ
        u16* currentATime,  // A ʱֵ λ 0.1ms
        u32* currentB,      // B 趨ֵ
        u16* currentBTime,  // B ʱֵ λ 0.1ms
        u8*  dynamicMode);  // ̬ģʽ PV_CONTINUE PV_PULSE PV_TOGGLED
    int  (*SetDynamicVArgs)(PComBody c,              // 0x34  øصĶ̬ѹֵ
        u32 VoltageA,       // ѹA 趨ֵ
        u16 VoltageATime,   // ѹA ʱֵ λ 0.1ms
        u32 VoltageB,       // ѹB 趨ֵ
        u16 VoltageBTime,   // ѹB ʱֵ λ 0.1ms
        u8  dynamicMode);   // ̬ģʽ PV_CONTINUE PV_PULSE PV_TOGGLED
    int  (*GetDynamicVArgs)(PComBody c,               // 0x35  ȡصĶ̬ѹֵ
        u32* VoltageA,      // ѹA 趨ֵ
        u16* VoltageATime,  // ѹA ʱֵ λ 0.1ms
        u32* VoltageB,      // ѹB 趨ֵ
        u16* VoltageBTime,  // ѹB ʱֵ λ 0.1ms
        u8*  dynamicMode);  // ̬ģʽ PV_CONTINUE PV_PULSE PV_TOGGLED
    int  (*SetDynamicPArgs)(PComBody c,               // 0x36  øصĶ̬ʲֵ
        u32 powerA,       // A 趨ֵ
        u16 powerATime,   // A ʱֵ λ 0.1ms
        u32 powerB,       // B 趨ֵ
        u16 powerBTime,   // B ʱֵ λ 0.1ms
        u8  dynamicMode); // ̬ģʽ PV_CONTINUE PV_PULSE PV_TOGGLED
    int  (*GetDynamicPArgs)(PComBody c,               // 0x37  ȡصĶ̬ʲֵ
        u32* powerA,      // A 趨ֵ
        u16* powerATime,  // A ʱֵ λ 0.1ms
        u32* powerB,      // B 趨ֵ
        u16* powerBTime,  // B ʱֵ λ 0.1ms
        u8*  dynamicMode);// ̬ģʽ PV_CONTINUE PV_PULSE PV_TOGGLED
    int  (*SetDynamicRArgs)(PComBody c,               // 0x38  øصĶֵ̬
        u32 resistanceA,     // A 趨ֵ
        u16 resistanceATime, // A ʱֵ λ 0.1ms
        u32 resistanceB,     // B 趨ֵ
        u16 resistanceBTime, // B ʱֵ λ 0.1ms
        u8  dynamicMode);    // ̬ģʽ PV_CONTINUE PV_PULSE PV_TOGGLED
    int  (*GetDynamicRArgs)(PComBody c,               // 0x39  ȡصĶֵ̬
        u32* resistanceA,    // A 趨ֵ
        u16* resistanceATime,// A ʱֵ λ 0.1ms
        u32* resistanceB,    // B 趨ֵ
        u16* resistanceBTime,// B ʱֵ λ 0.1ms
        u8*  dynamicMode);   // ̬ģʽ PV_CONTINUE PV_PULSE PV_TOGGLED
    SetGet8 (ListCVWR);                 // 0x3A 0x3B PV_CC ֻ
    SetGet8 (ListMode);                 // 0x3C 0x3D 0 ΪONCE, 1 ΪREPEATһΣԴ 65535Ϊѭ
    SetGet8 (ListStep);                 // 0x3E 0x3F ûȡList

    int (*SetListStepCTime)(              // 0x40 ûȡصӦĵֵʱֵб(40H/41H) 
        u16 step, u32 c, 
        u32 time, u16 rate);     // time 1 ʾ 0.1ms
    int (*GetListStepCTime)(              // 0x41
        u16 step, u32* c, 
        u32* time, u16* rate);  
    SetGet8 (ListPartition);            // 0x4A 0xAB ûȡصListģʽ (1|2|4|8)
    int  (*SaveListFile)(PComBody c,u8 u); // 0x4C Listļ(1~8) ram --> rom
    int  (*LoadListFile)(PComBody c,u8 u); // 0x4D Listļ(1~8) rom --> ram
    SetGet32(MinV);                     // 0x4E 0x4F ûȡڶѹģʽµСѹֵ

    SetGet16(ForloadTime);              // 0x50	0x51 øصFOR LOAD ON ʱʱֵ λ s
    SetGet8 (ForloadState);             // 0x52 0x53 (PV_OFF / PV_ON) ûȡFOR LOAD ON ʱ״̬
    int  (*SetNewAddr)(PComBody c,u8 addr);           // 0x54 øصͨѶַ
    int  (*SetLocalForbid)(PComBody c,u8 forbid);     // 0x55 ǷLOCAL ʹ PV_OFF / PV_ON 
    SetGet8 (RemoteMesure);             // 0x56 0x57 ûȡԶ̲ PV_Remote PV_Local
    SetGet8 (TrigMode);                 // 0x58 0x59 ûȡģʽ PV_TrigMAUNal PV_TrigEXTernal PV_TrigBUS PV_TrigHOLD
    int  (*SendBusSignal)(PComBody c);  // 0x5A ͸һBUS ʹź
    int  (*SetArgument)(PComBody c,u8 arg);           // 0x5B øز
    int  (*LoadArgument)(PComBody c,u8 arg);          // 0x5C ȡز
    SetGet8 (WorkMode);                 // 0x5D 0x5E ûȡģʽ (PV_WorkFIXED PV_WorkSHORT PV_WorkTRANSITION PV_WorkLIST PV_BATTERY)
    /*                                  // 0x5F ȡ״̬

    ״̬Ĵ
    7	6	5	4	3	2	1	0
    7 NO USE	
    6 LOT	FOR LOAD ON ʱ״̬
    5 SENSE	Զ˲ģʽ״̬
    4 LOCAL	LOCAL״̬(0 Ϊֹ,1 Ϊ)
    3 OUT	״̬
    2 REM	ΪԶ˿ģʽ
    1 WTG	ڵȴź
    0 CAL   У׼ģʽ
    						
    ѯ״̬Ĵ
    0	RV	뼫Է
    1	OV	ѹ
    2	OC	
    3	OP	
    4	OT	¶
    5	SV	Զû
    6	CC	
    7	CV	ѹ
    8	CW	
    9	CR	
    10	PASS	ԶԳɹ
    11	FAULT	Զʧ
    12	COMPLET	Զ
    */
    int  (*GetStates)(PComBody c,                     
        u32* actualInputV,  // ʵѹ
        u32* actualInputC,  // ʵ
        u32* actualInputW,  // ʵ빦
        u8*  operateState,  // ״̬Ĵ
        u16* queryState,    // ѯ״̬Ĵ
        u8*  fanTemperature,// ɢ¶
        u8*  workMode,      // ģʽ (0ΪPV_WorkFIXED1ΪPV_WorkSHORT
                            //           2ΪPV_WorkTRANSITION3ΪPV_WorkLIST)
        u8*  curlistStep,   // ǰLISTĲ
        u8*  curlistCirCnt  // ǰLISTѭ
        );

    // У׼
    SetGet8(AdjustProtect);             // 0x60 0x61 ûȡУ׼״̬  
    //      PV_AdjustProtectEnable PV_AdjustProtectDisable
    int  (*SetAdjustVPoint)(PComBody c,u8 u);         // 0x62 У׼صѹ  u ѹУ׼)(PComBody c,1 ~ 4)
    int  (*SetAdjustActualV)(PComBody c,u32 v);      // 0x63 ȡǰʵѹ
    int  (*SetAdjustCPoint)(PComBody c,u8 u);         // 0x64 У׼ص  u У׼)(PComBody c,1 ~ 4)
    int  (*SetAdjustActualC)(PComBody com,u32 c);      // 0x65 ȡǰʵ
    int  (*SaveAdjust)(PComBody c);                  // 0x66 渺صУ׼ݵEEPROM
    int  (*SaveAdjustInfo)(PComBody c,                // 0x67 У׼Ϣ Ҫ20ֽ
        const char* info); 
    // !!! ÷ info ռ 
    // char info[27];
    // com->GetAdjustInfo(c, info);
    int  (*GetAdjustInfo)(PComBody c,char info[27]);   // 0x68 ȡУ׼Ϣ  !!! 
    int  (*SetAdjustInit)(PComBody c);               // 0x69 ָصУ׼Ϊʼֵ
    int  (*GetDevInfo)(PComBody c,                    // 0x6A ȡƷϢ
        char product[27],    // Ʒͺ 8511?   6011? ϢΪ 0x60У׼
        char softVersion[27],// 汾ͺ
        char sequence[27]    // Ʒк
        );      
    // TODO: ע
    int  (*GetPowerInfo)(PComBody c,char power[27]);   // 0x6B ȡԴϢ

    SetGet32(OCPValue);                 // 0x80 0x81 ûȡֵ
    SetGet8 (OCPTime);                  // 0x82 0x83 ûȡʱʱ
    SetGet8 (OCPState);                 // 0x84 0x85 ûȡʹ/ʧ״̬
    SetGet32(OPPValue);                 // 0x86 0x87 ûȡʱֵ
    SetGet8 (OPPTime);                  // 0x88 0x89 ûȡʱʱʱ
    SetGet32(TimeV1);                   // 0x8A 0x8B ûȡʱĵ1Ƚϵѹ
    SetGet32(TimeV2);                   // 0x8C 0x8D ûȡʱĵ2Ƚϵѹ
    SetGet32(LEDV);                     // 0x8E 0x8F ûȡCR_LEDģʽĽֹѹֵ

    int  (*ClearProtect)(PComBody c);             // 0x90 ״̬
    SetGet8 (VAutoState);               // 0x91 0x92 ûȡѹԶ״̬PV_OFF PV_ON
    SetGet8 (CRLED);                    // 0x93 0x94 ûȡCRģʽʱCR_LEDPV_OFF PV_ON
    SetGet8 (Keydown);                  // 0x98 ģ̰ keyCodeģֵ̱
    // 0x99 ȡһμֵ keyCode һμֵ,0 
    SetGet8 (VFDMode);                  // 0x9A 0x9B ûȡVFDʾģʽ PV_VFDNormal PV_VFDText
    int  (*SetVFDText)(PComBody c,u8 startPos,        // 0x9C VFDʾ
        const char* text);
    int  (*SendTrig)(PComBody c);                    // 0x9D ܴԴʲôź

    int  (*GetStates2)(PComBody c,                    // 0xA0 ȡ2
        u32* capacity,  // 
        u32* time,      // ʱ/½ʱ(ֽǰ,ֽں) 
        u32* restTimer);// ʱʣʱ        
    int  (*GetStates3)(PComBody c,                    // 0xA1 ȡ3
        u32* maxInputV,  // ѹֵ
        u32* minInputV,  // Сѹֵ
        u32* maxInputC,  // ֵ
        u32* minInputC); // Сֵ
    int  (*GetMaxInputV)(PComBody c,u32* v);          // 0xA2 ȡѹֵ
    int  (*GetMinInputV)(PComBody c,u32* v);          // 0xA3 ȡСѹֵ
    int  (*GetMaxInputC)(PComBody com,u32* c);        // 0xA4 ȡֵ
    int  (*GetMinInputC)(PComBody com,u32* c);        // 0xA5 ȡСֵ
    int  (*GetCapacity)(PComBody c,u32* capacity);    // 0xA6 ȡصĴֵ

    SetGet32(CUpRate);                  // 0xB0 0xB1 õб
    SetGet32(CDownRate);                // 0xB2 0xB3 õб
    SetGet32(CCMaxVoltage);             // 0xB4 0xB5 öʱѹ
    SetGet32(CCMinVoltage);             // 0xB6 0xB7 öʱѹ
    SetGet32(CVMaxCurrent);             // 0xB8 0xB9 öѹʱ
    SetGet32(CVMinCurrent);             // 0xBA 0xBB öѹʱ
    SetGet32(CPMaxVoltage);             // 0xBC 0xBD öʱѹ
    SetGet32(CPMinVoltage);             // 0xBE 0xBF öʱѹ

    SetGet32(MaxInputR);                // 0xC0	0xC1 ûȡֵ
    SetGet32(CRMaxVoltage);             // 0xC2 0xC3 ûȡʱѹ
    SetGet32(CRMinVoltage);             // 0xC4 0xC5 ûȡʱѹ
    SetGet32(ListC);                    // 0xC6 0xC7 ûȡLISTģʽʱ

    SetGet16(StepNumber);               // 0xD0 0xD1 ûȡԶʹõĵ
    SetGet16(ShortStep);                // 0xD2 0xD3 ûȡԶԶ·ĵ
    SetGet16(PauseStep);                // 0xD4 0xD5 ûȡԶͣĵ

    int  (*SetStepOnTime)(PComBody c,u8 step, u32 time);// 0xD6 ԶԵĴʱ
    int  (*GetStepOnTime)(PComBody c,u8 step, u32* time);// 0xD7
    int  (*SetStepOffTime)(PComBody c,u8 step, u32 time);// 0xDA ԶԵжʱ
    int  (*GetStepOffTime)(PComBody c,u8 step, u32* time);// 0xDB
    SetGet8(StepStop);                  /* 0xDC 0xDD ûȡԶֹͣ
                                          (0Ϊֹͣ,1Ϊʧֹͣ) */
    SetGet8(LinkFile);                  // 0xDE 0xDF ûȡԶļ

    void (*AckToString)(PComBody c,char s[27]);
    void (*SendToString)(PComBody c,char s[27]);
}ZELComI, *PZELComI;

#undef SetGet8
#undef SetGet16
#undef SetGet32

COM_API PZELComI GetZELComI(void);
/*

PZELComI com = GetZELComI();
PComBody comBody = com->Create();
com->Init(comBody, "COM5", 9600, 0);
com->Destroy(&comBody);

*/

#ifdef  __cplusplus
}
#endif

#endif